Subject: bug#54043: closed (Re: bug#54043: Simple regexp bug [contains spoiler for today's wordle])

From: [email-masked] (GNU bug Tracking System)
Date: Thu, 17 Feb 2022 16:15:02 +0000

Your bug report

#54043: Simple regexp bug [contains spoiler for today's wordle]

which was filed against the grep package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
54043: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=54043
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#54043: Simple regexp bug [contains spoiler for today's wordle]
From: Jim Meyering <[email-masked]>
To: Matthew Wilcox <[email-masked]>
Cc: [email-masked]
Date: Thu, 17 Feb 2022 08:13:54 -0800
List-Id: <debbugs-submit.debbugs.gnu.org>

On Thu, Feb 17, 2022 at 7:46 AM Matthew Wilcox <[email-masked]> wrote:
> I noticed this one while doing:
>
> $ grep sha[^s]e five-letter-words
> share
>
> which doesn't fit with:
>
> $ grep sha.e five-letter-words
> shade
> shake
> shale
> shame
> shape
> share
> shave
>
> A reproducer is easy:
>
> $ echo shame |grep sha[^s]e
> (no output)

This is not a bug in grep. Your failure to quote the regular expression
means that the argument is first interpreted by the shell.
To demonstrate the argument that "grep" ends up using,
run this from that same directory:

  echo sha[^s]e

If I have something named e.g., "shape" in the current directory, that
would print "shape". If I have two matching names, e.g., shave and shale,
it will print both names.

IMHO, it is almost always best to single-quote regular expressions like that.
Quoting your reproducer, you see it works as desired:

  $ echo shame |grep 'sha[^s]e'
  shame

Subject: Simple regexp bug [contains spoiler for today's wordle]
From: Matthew Wilcox <[email-masked]>
To: [email-masked]
Date: Thu, 17 Feb 2022 14:47:04 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

I noticed this one while doing:

$ grep sha[^s]e five-letter-words
share

which doesn't fit with:

$ grep sha.e five-letter-words
shade
shake
shale
shame
shape
share
shave

A reproducer is easy:

$ echo shame |grep sha[^s]e
(no output)

Almost any change to the regex & input will make it work, even rot-13
of both.  For example:

$ echo shamel |grep sha[^s]e
(no output, still fails)
$ echo shamel |grep sha[^s]el
shamel
$ echo sshame |grep ssha[^s]e
sshame
$ echo funzr |grep fun[^f]r
funzr

$ grep --version
grep (GNU grep) 3.7
Copyright (C) 2021 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later <https://gnu.org/licenses/gpl.html>.
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law.

Written by Mike Haertel and others; see
<https://git.sv.gnu.org/cgit/grep.git/tree/AUTHORS>.

This is Debian amd64, grep package version 3.7-1.